<template>
    <section>
        <div class="container">
            <div class="row">
                <div class="shadow-lg col-12 mt-4 p-3 mb-5 bg-white rounded">
                <div class="float-left">
                  <a href="javascript:window.history.go(-1);"><i class="material-icons">arrow_back_ios</i> Regresar</a>
                </div>
                    <h2 class="text-center">Pase de lista</h2>
                </div>
          <div class="col-md-6">
            <div class="card">
              <div class="card-body">
                <h5 class="card-title">Selecciona tu horario</h5>
                  <form>
                      <div class="row form-group">
                          <div class="col">
                              <label for>Horario</label>
                              <select v-model="horarioId" class="form-control">
                                  <option v-for="(horario,index) in horarios.response.listaHorario" :key="index" :value="horario.id +'*'+horario.horaInicio">
                                      {{horario.horaInicio}} - {{horario.horaFin}}
                                  </option>
                              </select>
                          </div>
                      </div>
                  </form>
              </div>
            </div>
          </div>
          <div class="col-md-6">
            <div class="card">
              <div class="card-body">
                 <div class="col">
                   <form @change="listaAsistencia">     
                    <label for>Fecha</label>
                    <input type="date" class="form-control" v-model="date" />
                   </form>
                </div>
              </div>
            </div>
          </div>
         
            </div>
            <!-- <div class="row shadow" style="border-radius: 5px">
                <div v-if="listasAspirantes.listaAspirantes.length === 0">
                   <div class="alert alert-danger" role="alert" v-if="aspirants.length === 0">
                        <h2 class="lead">No se cuenta con Aspirantes registrados</h2>
                    </div>
                </div>
            </div> -->
          <div class="row shadow-lg">
            <table class="table table-hover table-light" v-show="listasAspirantes.length>0">
                <thead>
                    <tr style="background-color: #019979">
                    <!-- <th scope="col" class="text-white lead">#</th> -->
                    <th scope="col" class="text-white lead">NOMBRE</th>
                    <th scope="col" class="text-white lead">ASISTENCIA</th>
                    </tr>
                </thead>
                <tbody>
                    <tr v-for="(aspirant,index) in listasAspirantes" :key="index" class="table-light lead">
                    <!-- <th scope="row">{{index}}</th> -->
                    <td>{{aspirant.nombre}} {{aspirant.primerApellido}} {{aspirant.segundoApellido}}</td>
                    <td>
                        <select v-model="aspirant.estado" class="form-control">
                          <option
                          v-for="(estadoAsistencia,index) in horarios.response.listaEstadoAsistencia"
                          :key="index"
                          :value="estadoAsistencia.id">
                          {{estadoAsistencia.estado}}
                          </option>
                        </select>
                        
                    </td>
                    </tr>
                </tbody>
                </table>
                <b-button @click="enviarLista" variant="outline-success">Enviar Lista</b-button>
            </div>
        </div>
    </section>    
    
</template>


<style scoped>
a{
    color: white;
}
</style>


<script>
import axios from "axios";
import { server } from '../../store'

export default {
    data(){
        return{
            horarios: [],
            user:[],
            horarioId: null,
            listasAspirantes:[],
            estadoAsistencia:null,
            output:null,
            date:null
        }
    },
    mounted(){
        if(localStorage.getItem('usuario') == null){
          this.$router.push("/login");
        }else{
          this.user = JSON.parse(localStorage.getItem('usuario'));
        }
        this.obtenerHorarios();
    },
    methods:{
        enviarLista(){
          let listaEnvio = [];
          // alert(JSON.stringify(this.listasAspirantes))
              for (var x=0;x<this.listasAspirantes.length;x++){
                  // alert(this.listasAspirantes[x].nombre);
                  let array = this.horarioId.split("*");
                  let idH = array[0];
                  listaEnvio.push({idAspirante: this.listasAspirantes[x].id, 
                                  idHora: parseInt(idH), 
                                  estado: this.listasAspirantes[x].estado});
               }
               console.log(listaEnvio);
                let objeto = this;
                let array = this.horarioId.split("*");
                let hora = array[1];
                axios
                  .post(`${server.baseURL}/api/grupo-horario/registro`, {
                    registro: {
                      hora: hora,
                      fechaActual: "2019-12-16",
                      lista: listaEnvio
                    }
                  })
                  .then(function(response) {
                    objeto.output = response.data;
                    // objeto.pasarListas();
                  })
                  .catch(function(error) {
                    objeto.output = error;
                  });
        },
        obtenerHorarios(){
            let objeto = this;
            axios
              .post(`${server.baseURL}/api/grupo-horario/horarios`, {
                docente: {
                  id: this.user.id
                }
              })
              .then(function(response) {
                objeto.horarios = response.data;
                objeto.pasarListas();
              })
              .catch(function(error) {
                objeto.output = error;
              });
        },
        pasarListas(){
        this.listasAspirantes = this.output.response.listaAspirantes
      },
        listaAsistencia(){
            let objeto = this;
            let array = this.horarioId.split("*");
            let idH = array[0];
            let hora = array[1];
          axios
              .post(`${server.baseURL}/api/grupo-horario/listaAsistencia`, {
                docente: {
                  hora: hora,
                  idDocente: this.user.id,
                  idHora: parseInt(idH),
                  fecha: this.date
                }
              })
              .then(function(response) {
                objeto.output = response.data;
                objeto.pasarListas();
              })
              .catch(function(error) {
                objeto.output = error;
              });
        }
        }
    }

</script>